#include "wave.h"
#include "gsm/inc/gsm.h"

char *USAGE =

"USAGE: %s [options] [<wave-file>]\n"
"Converts 16 bit mono wave-file to GSM.\n"
"Options: -o<output file>, -h print this message, -v verbose mode\n";

gsm handle;
gsm_frame buf;
gsm_signal sample[160];


int main(int argc,char **argv)
{
  wavfile w,g;
  LONGINT i,j;
  char c;

  setexitmsg(argv[0]);
  g.f=stdout;
  while(1)
  {
    c=getopt(argc,argv,"o:hv");
    if(stdopt(c,USAGE)) break;
    switch(c)
    {
      case 'o': g.f=fileopen(optarg,"wb",0);
    };
  };
  if(optind<argc-1) errexit(ERR_ARG);
  
  if(optind<argc)
    wavfin(&w,argv[optind]);
  else
    wavstdin(&w);

  if(w.bits!=16) {
    fprintf(stderr,"%s: Input file is not 16 bit.\n",PRG);
    errexit(ERR_FORMAT);
  }

  if (!(handle = gsm_create())) exit(1);

  while (w.i<w.n) {
    for(j=0;j<160;j++) sample[j]= (w.i<w.n) ? wavbinget(&w) : 0;
    gsm_encode(handle, sample, buf);
    fwrite((char *)buf, sizeof(buf),1,g.f);
  }   
}

